import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * "The Autumn of the Patriarch: the videogame".
 * By: Jhoan Vinazco, Harold Fonseca, Brayan Quiroga
 
 * One of the most famous novels of the colombian writer 
   Gabriel Garcia Marquez is now available in Greenfoot.
 
 * Industrial University of Santander
 * Oriented Objects Programation
 * Bucaramanga, Colombia.
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    private int vSpeed; //velocidad vertical
    private int acceleration; //aceleracion (gravedad)
    private boolean jumping; // está saltando?
    private int jumpStrength; //fuerza del salto
    protected boolean movingLeft;
    protected boolean movingRight;
    
    public Player()
    {
        vSpeed=0;
        acceleration=2;
        jumping=false;
        jumpStrength=23;
        movingLeft=false;
        movingRight=true;
    }
    
    public void act() 
    {
        // Add your action code here.
        move();
        checkFall();
        checkKey();
        platformAbove();
        isMovingLeft();
        isMovingRight();
    }
    
    public void checkKey() //comrobar tecla (para saltar)
    {
        if(Greenfoot.isKeyDown("up")&&jumping==false) //oprimir tecla arriba y que "saltando" sea falso para poder saltar
        {
            jump();
            //checkPlatform();
        }
    }
    
    public void move()
    {
        if(Greenfoot.isKeyDown("left"))
        {
            //setImage("General L.png");
            movingRight=false;
            movingLeft=true;
            move(-4);
        }
        if(Greenfoot.isKeyDown("right"))
        {
            //setImage("General R.png");
            movingLeft=false;
            movingRight=true;
            move(4);
        }
    }
    
    public boolean isMovingRight()
    {
        return movingRight;
    }
    
    public void setMovingRight(boolean movingRight)
    {
        this.movingRight=movingRight;
    }
    
    public boolean isMovingLeft()
    {
        return movingLeft;
    }
    
    public void setMovingLeft(boolean movingLeft)
    {
        this.movingLeft=movingLeft;
    }
    
    public void settingImage()
    {
        //sobrecargar en la clase de cada personaje
    }
    
    public void fall() //caer
    {
        setLocation(getX(),getY()+vSpeed);
        vSpeed=vSpeed+acceleration;
        jumping = true;
    }
    
    public boolean onGround() //está encima del suelo (plataforma)?
    {
        int spriteHeight = getImage().getHeight();
        int yDistance = (int) (spriteHeight/2+5);
        
        Actor ground = getOneObjectAtOffset(0,getImage().getHeight()/2, Platform.class);
        if(ground==null)
        {
            jumping = true;
            return false;
        }else{
            moveToGround(ground);
            return true;
        }
    }
    
    public boolean platformAbove(){
        int spriteHeight = getImage().getHeight();
        int yDistance = (int) (spriteHeight / -2);
        
        Actor ceiling = getOneObjectAtOffset(0, yDistance, Platform.class);
        if(ceiling!=null)
        {
            vSpeed = 1;
            bopHead(ceiling);
            return true;
        }else{
            return false;
        }
    }
    
    public void bopHead(Actor ceiling)
    {
        int ceilingHeight = ceiling.getImage().getHeight();
        int newY = ceiling.getY() + (ceilingHeight+getImage().getHeight())/2;
        setLocation(getX(),newY);
    }
    
    public void moveToGround(Actor ground)
    {
        int groundHeight = ground.getImage().getHeight();
        int newY = ground.getY()-(groundHeight+getImage().getHeight())/2;
        
        setLocation(getX(),newY);
        jumping = false;
    }
    
    public void checkFall() //comprobar si está cayendo
    {
        if(onGround()){ // si está sobre el suelo
            vSpeed=0; //velocidad vertical: 0
        }else{
            fall(); //sino: ¡me caigo!
        }
    }
    
    public void jump() //saltar
    {
        vSpeed = vSpeed - jumpStrength; //velocidad vertical - fuerza de salto
        jumping = true; //saltando? si!
        fall(); //y luego cae :v
    }
    
    public void catchObject(){//capturar un objeto
        //sobreescribir
    }
}
